<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Feature-Search"			                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.1 / Mrz 2013

*/

if (!defined('CPO')) exit;
$translator->addTranslation('navigation', CPO_BASEDIR.$moduleDirectory.'/lang');

if (!isset($_POST['go']) && license($activeModules[$moduleDirectory]['lkey'],$activeModules[$moduleDirectory]['mod_id'])!=1 && license($activeModules[$moduleDirectory]['lkey'],$activeModules[$moduleDirectory]['mod_id'])!=3) {
    $message[] = ___('The feature search is currently disabled due to missing license.');
}


$GLOBALS['modules'][$moduleDirectory] = array(
    'directory'=>$moduleDirectory,
    'caption'=>__('Feature-Search') . ' ('.$moduleDirectory.')',
    'install'=>'function: Feature_Search_install',
    'activate'=>'function: Feature_Search_activate',
    'deactivate'=>'function: Feature_Search_deactivate',
    'uninstall'=>'function: Feature_Search_uninstall '.$moduleDirectory,
	'manage'=>'function: Feature_Search_manage '.$moduleDirectory,
	'owner'=>$cpoSystem['owner'],
	'lkey'=>'',
	'mod_id'=> 17,
	// Grundwerte
	'noOfResults'=>'5',
	'dateFormat'=>$cpoSystem['date_format'],
	'showArticles'=>'above',
	'hideArticles'=>'yes',
	'pagetemplate_index'=>0,
	'template'=>'
<!-- START_MOD_SEARCH -->
<p>Geben bitte den gewnschten Suchbegriff ein.</p>
<form name="suchergebnisse" class="result" method="get" action="index.php" style="display: ### SEARCH_FORM ###;">
  <table border="0" cellspacing="5" cellpadding="0">
  <tr>
    <td><label for="p1">Titel </label></td>
    <td>
      <input type="text" name="p1" id="p1" value="### SEARCH_PHRASE_1 ###" />
      <input type="hidden" name="sv1" value="titel" />
    </td>
  </tr>
  <tr>
    <td><label for="p2">Teaser </label></td>
    <td>
      <input type="text" name="p2" id="p2" value="### SEARCH_PHRASE_2 ###" />
      <input type="hidden" name="sf2" value="Teaser" />
    </td>
  </tr>
  <tr>
    <td>&nbsp;</td>
    <td><input type="submit" value="Suche"></td>
  </tr>
  </table>
  <input type="hidden" name="action" value="feature_search" />
  <input type="hidden" name="results" value="AND" />
  <input type="hidden" name="rubric" value="### SEARCH_NAV ###" />
</form>
### SEARCH_MESSAGE ###
<br />&nbsp;<br />
### SEARCH_MATCHES ###
<!-- START_SEARCH_MATCH -->
<div class="morelink">### SEARCH_NUM ###.) <a href="../### SEARCH_RUBRIC_DIR ###/detail.php?nr=### SEARCH_ARTICLE_ID ###&rubric=### SEARCH_RUBRIC ###">### SEARCH_TITLE ###</a></div>
<!-- ENDE_SEARCH_MATCH -->
### SEARCH_PAGES ###
<!-- ENDE_MOD_SEARCH -->
',
	'noSearchstringText'=>__('Please fill in a search phrase!'),
	'noMatchesText'=>__('No contents matching your search phrase!'),
	'matchesText'=>__('<h1>The search delivered %s matches for your search phrase!</h1>'),
	'rubricsUse'=>'off',
	'defaultPattern'=>"LIKE '%###%'",
	'aPattern'=>"###",
	'bPattern'=>"LIKE '###%'",
	'cPattern'=>"LIKE '%###'",
	'dPattern'=>"> ###",
	'ePattern'=>"< ###",
	'sortingField'=>'titel',
	'sortingOrder'=>'ASC',
    'helptoc'	=> array(
        'bersicht' 
			=> 'http://manual.conpresso4.de/feature_search/index.htm',
        '1. Eigenschaften' 
			=> 'http://manual.conpresso4.de/feature_search/features.htm',
        '2. Installation' 
			=> 'http://manual.conpresso4.de/feature_search/setup.htm',
        '3. Einstellungen' 
			=> 'http://manual.conpresso4.de/feature_search/settings.htm',
        '4. Anwendung' 
			=> 'http://manual.conpresso4.de/feature_search/application.htm'
		)
);

if (!function_exists('Feature_Search_manage'))  {
	function Feature_Search_manage($moduleDirectory)
	{
		global $module_status, $k;
		printIcon(	
			BASE_ABS.$moduleDirectory.'/edit.php?list=options', 
			BASE_ABS.'_skin/conpresso/pic_settings.gif', 
			(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE) ? __('options') : __('not available'),
			array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE
		);
	}
}

if (!function_exists('log_mod_feature_search'))  {
	function log_mod_feature_search()  {
		global $cpoSystem;
		@mail('kontakt@conpresso4.de','Das Modul Feature Suche 4.1 wurde unter '.BASE_ABS.' installiert','','From: '.$cpoSystem['admin_email']);
	}
}

if (!function_exists('Feature_Search_install'))  {
	function Feature_Search_install()
	{
		$fsdb = new DB;
		$fsdb->query("INSERT INTO ".CPO_OPTION." (type, options, id) VALUES ('feature_search', '".serialize(array("installed"=>time()))."', '') ");
		log_mod_feature_search();
		$GLOBALS['message'][] = __('The Feature-Search-module was successfully installed!');
	}
}
if (!function_exists('Feature_Search_activate'))  {
	function Feature_Search_activate()
	{
		$GLOBALS['message'][] = __('The Feature-Search-module got activated.');
	}
}
if (!function_exists('Feature_Search_deactivate'))  {
	function Feature_Search_deactivate()
	{
		$GLOBALS['message'][] = __('The Feature-Search-module got deactivated.');
	}
}
if (!function_exists('Feature_Search_uninstall'))  {
	function Feature_Search_uninstall($directory_uninstall)
	{
		$GLOBALS['message'][] = sprintf(__('Please remove the module directory %s to finally uninstall the Feature-Search-module.'), '<em>'.htmlspecialchars($directory_uninstall, ENT_COMPAT, 'ISO-8859-15').'</em>');
	}
}

if (!$activeModules[$moduleDirectory]['installed'])  {
	$fsdb = new DB;
	$fsdb->query('SELECT options FROM '.CPO_OPTION.' '
			  ."WHERE type='feature_search' ORDER BY id ASC LIMIT 0,1");
	while ($fsdb->next_record()) {
		$options = $fsdb->v('options');
		$fsOpt = unserialize($options);
		if (!is_array($fsOpt)) break;
		foreach ($fsOpt as $key=>$v) {
			$activeModules[$moduleDirectory][$key] = $v;
		}
	}
}

?>
