<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Feature-Search"			                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.1 / Mrz 2013

*/

if (!defined('CPO')) exit;

$templates = array();
$rubrics   = array();
$results   = array();
$fmatches   = array();
$results_output_fields   = array();
$noOfResults = $activeModules[$directory]['noOfResults'];
if (!$_REQUEST['results']) $_REQUEST['results'] = "OR";

// Fehlercheck
if (isset($_POST['go']) && empty($_POST['cpoSearchNew']['noOfResults'])) $_POST['cpoSearchNew']['noOfResults'] = $cpoSystem['noOfArticles'];
if (isset($_POST['go']) && empty($_POST['cpoSearchNew']['dateFormat'])) $_POST['cpoSearchNew']['dateFormat'] = $cpoSystem['date_format'];


// Moduleinstellungen speichern (neue Version mit automatischem Einlesen neuer Variablen) ************************
if (isset($_POST['go'])) {
	$new_settings = $_POST;
    foreach ($activeModules[$directory] as $k=>$v) {
        if (!isset($_POST['cpoSearchNew'][$k])) continue;
        if (is_bool($activeModules[$directory][$k])) {
            $activeModules[$directory][$k] = (bool) $_POST['cpoSearchNew'][$k];
        } else {
			$activeModules[$directory][$k] = $_POST['cpoSearchNew'][$k];
		}
		if (array_key_exists($k, $new_settings['cpoSearchNew'])) unset($new_settings['cpoSearchNew'][$k]);
    }
    foreach ($new_settings['cpoSearchNew'] as $k=>$v) {
		$activeModules[$directory][$k] = $new_settings['cpoSearchNew'][$k];
	}
    $c_datum = date ("Y-m-d H:i:s", time());
    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = '%s'", 
            addslashes(serialize($activeModules[$directory])),
			$directory
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = __('Module settings were updated!');
}

// Die eigentliche Suche ****************************************************************************************
if ($_REQUEST['action'] == 'feature_search')  {

	// Rubrikeneinschrnkung
	$qrubrics = '';
	if (isset($activeModules[$directory]['rubrics']) && $activeModules[$directory]['rubricsUse'] != 'off') {
		$qrubrics = 'AND '.CPO_NEWS.'.rubric_id '.$activeModules[$directory]['rubricsUse'].' (';
		$c = '';
		foreach ($activeModules[$directory]['rubrics'] as $v) {
			$qrubrics .= $c.(int)$v;
			$c = ', ';
		}
		$qrubrics .= ') ';
	}

	if (!isset($activeModules[$directory]['rubrics']) && $activeModules[$directory]['rubricsUse'] != 'off') $qrubrics = 'AND '.CPO_NEWS.'.rubric_id '.$activeModules[$directory]['rubricsUse'].' (0)';

	// geschlossene Rubriken und personalisierte Artikel, die der User sehen darf
	$sec_rubrics .= 'AND (seclevel=0';
	$query = "SELECT rubric_id FROM " . CPO_RUBRIC_PERMISSION  ." WHERE usergroups_id='" . addslashes($_SESSION['SID_user']['usergroups_id']) . "'";
	DEBUG(2, $query, __FILE__, __LINE__);   
	$db_sec = new DB;
	$db_sec->query($query);
	if ($db_sec->num_rows()>0)  {
		$sec_rubrics .= ' OR '.CPO_NEWS.'.rubric_id IN (';
		$c = '';
		while ($db_sec->next_record())  {
			$sec_rubrics .= $c.(int)$db_sec->v('rubric_id');
			$c = ', ';
		}
		$sec_rubrics .= ')';
	}
	if ($_SESSION['SID_user']['usergroups_id']>0) {
		$sec_rubrics .= " OR auth LIKE '%#".$_SESSION['SID_user']['usergroups_id']."#%'";  
	}
	$sec_rubrics .= ') ';

	// Das Datum
	$pubdatum = "AND pub_datum<='".date('Y-m-d H:i:s', time())."' AND verfallsdatum>='".date('Y-m-d H:i:s', time())."' ";

	// Die Freigabe
	$freigabe = 'AND '.($cpoSystem['release'] ? 'artikel_archiv<2 AND freigabe='.STATE_RELEASED.' ' : 'artikel_archiv<1 AND freigabe!='.STATE_BLOCKED.' ');

	$permission = '';
	$perm_table = '';
	$perm_stufe4 = '';
	if ($_SESSION['SID_user']['id'] && $close_backend)  {
		$permission = 'AND '.CPO_PERMISSION.'.rubric_id = '.CPO_RUBRIC.'.id AND '.CPO_PERMISSION.'.user_id = '.addslashes($_SESSION['SID_user']['id']).' ';
		$perm_table = ', '.CPO_PERMISSION;
		$perm_stufe4 = ', stufe4';
	}


	// hier beginnt die eigentliche Suche
	// *********************************************************************************************************************

	// pn = Phrase n
	// sfn = SearchField n
	// smn = SeachMask n
	// spn = SelectPhrase n
	// vn = Value n

	// hier beginnen wir mit 1 und schauen wieviele Suchparameter es gibt. Daher mssen diese in lckenlos von 1 aufwrts nummeriert sein
	
//	$z = 1;
	for ($z=1;$z<=100;$z++)  {
		if (!array_key_exists('p'.$z,$_REQUEST) && !array_key_exists('sv'.$z,$_REQUEST) && !array_key_exists('sf'.$z,$_REQUEST) && !array_key_exists('sp'.$z,$_REQUEST)) continue;
		if (array_key_exists('sp'.$z,$_REQUEST))
		{
			$_REQUEST['p'.$z] = $_REQUEST['sp'.$z];
			$selects[$z] = $_REQUEST['sp'.$z];
		}
		// die Suchfelder vorbereiten, um spter zu prfen, ob auch jedes gefllte Feld bercksichtigt wurde
		if ($_REQUEST['p'.$z] != '' && $_REQUEST['sf'.$z] != '') $searchFields[$_REQUEST['sf'.$z]]=Array();
		if ($_REQUEST['p'.$z] != '' && $_REQUEST['sv'.$z] != '') $searchFields['value']=Array();
		// fr Select und Optionsfelder bei denen sf=p sein soll!
		if ($_REQUEST['sf'.$z] == '' || (!isset($_REQUEST['sf'.$z]) && !isset($_REQUEST['sv'.$z]))) 
		{
			$_REQUEST['sf'.$z] = $_REQUEST['p'.$z];
			if ($_REQUEST['p'.$z] != '' && !isset($_REQUEST['sv'.$z])) $searchFields[$_REQUEST['sf'.$z]]=Array();
		}
//		$z++;
	}
//	$searched_features = $z-1;
//	print_r($searchFields);
//	echo "<hr /> ";

//	$z = 1;
	$num_phrases = 0;
	$request_val_string = " AND ( ";
	$request_text_string = " AND ( ";
	$request_html_string = " AND ( ";
	for ($z=1;$z<=100;$z++)  {
		if (!array_key_exists('p'.$z,$_REQUEST) && (!array_key_exists('sf'.$z,$_REQUEST) || !array_key_exists('sv'.$z,$_REQUEST)) ) continue;
		if (trim($_REQUEST['p'.$z]) != '')
		{
			$suchstring = (array_key_exists('sm'.$z,$_REQUEST)) ? 
				str_replace('###',addslashes($_REQUEST['p'.$z]),$activeModules[$directory][$_REQUEST['sm'.$z].'Pattern']) :
				str_replace('###',addslashes($_REQUEST['p'.$z]),$activeModules[$directory]['defaultPattern']);
			if ($_REQUEST['sv'.$z] != '') {
				$request_val_string .= ($request_val_string != " AND ( ") ? " ".$_REQUEST['results']." " : "";
				$request_val_string .= "( ".addslashes($_REQUEST['sv'.$z])." ".$suchstring." )";
			}
			else {
				$request_text_string .= ($request_text_string != " AND ( ") ? " OR " : "";
				$request_text_string .= "( fieldname = '".addslashes($_REQUEST['sf'.$z])."' AND text ".$suchstring." )";
				$request_html_string .= ($request_html_string != " AND ( ") ? " OR " : "";
				$request_html_string .= "( fieldname = '".addslashes($_REQUEST['sf'.$z])."' AND html ".$suchstring." )";
			}
			$num_phrases += 1;
		}
//		echo "Suche: ".addslashes($_REQUEST['sf'.$z])." ".$suchstring."<br />";
//		$z++;
	}
	
	$request_val_string .= " ) ";
	$request_text_string .= " ) ";
	$request_html_string .= " ) ";

	if ($request_val_string == " AND (  ) ") unset ($request_val_string);
	if ($request_text_string == " AND (  ) ") unset ($request_text_string);
	if ($request_html_string == " AND (  ) ") unset ($request_html_string);

//	echo $request_text_string;
//	echo "<br /> ";
//	echo $request_html_string;
//	echo "<br /> ";
	if ($num_phrases == 0)
	{
		unset ($request_text_string, $request_html_string, $request_val_string);
		return;
	}

	// jetzt prfen wir erstmal, welche Artikel berhaupt in Frage kommen. Dazu prfen wir, ob irgendeine Phrase vorkommt und speichern die Nummern der Artikel

	// search values
	if ($request_val_string) {
		$query = 'SELECT artikel_archiv, freigabe, nr, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, verfallsdatum, seclevel, changer, last_modify'.$perm_stufe4.' FROM '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
			.'WHERE '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
			.$permission
			.$request_val_string
			.$freigabe
			.$pubdatum
//			.$sec_rubrics
			.$qrubrics;
//		echo $query;
//		echo "<br /> ";
		$db->query($query);
		while ($db->next_record_assoc()) {
			$recNr = $db->v('nr');
			$results[$recNr] = $db->record();
			$fmatches[$recNr]='value'; // die Artikelnummer und das getroffene Feld
			$searchFields['value'][] = $recNr; 
			$results[$recNr]['result'] = strip_tags($results[$recNr]['html']); // der html-Inhalt ohne tags
			$results[$recNr]['sort_date'] = $results[$recNr]['pub_datum']; // das Datum wozu?
			// tagsPreg um die genaue Position des Platzhalters festzustellen (index/archive oder detail)
//			$results[$recNr]['fieldnamePreg'] = '/<!--\s*(file|html|image|text|url|value)\s*:\s*('.preg_quote($results[$recNr]['fieldname']).')\s*(;\s*(.*?)\s*)?-->/si';
		}
	}
	// search HTML fields
	if ($request_html_string) {
		$query = 'SELECT fieldname, artikel_archiv, freigabe, nr, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, html, verfallsdatum, seclevel, changer, last_modify'.$perm_stufe4.' FROM '.CPO_CONTENT_HTML.', '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
			.'WHERE '.CPO_CONTENT_HTML.'.article_id = '.CPO_NEWS.'.nr '
			.'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
			.$permission
			.$request_html_string
			.$freigabe
			.$pubdatum
//			.$sec_rubrics
			.$qrubrics;
//		echo $query;
	//	echo "<br /> ";
		$db->query($query);
		while ($db->next_record_assoc()) {
			$recNr = $db->v('nr');
			$results[$recNr] = $db->record();
			$fmatches[$recNr]=$results[$recNr]['fieldname']; // die Artikelnummer und das getroffene Feld
			$searchFields[$results[$recNr]['fieldname']][] = $recNr; 
			$results[$recNr]['result'] = strip_tags($results[$recNr]['html']); // der html-Inhalt ohne tags
			$results[$recNr]['sort_date'] = $results[$recNr]['pub_datum']; // das Datum wozu?
			// tagsPreg um die genaue Position des Platzhalters festzustellen (index/archive oder detail)
//			$results[$recNr]['fieldnamePreg'] = '/<!--\s*(file|html|image|text|url|value)\s*:\s*('.preg_quote($results[$recNr]['fieldname']).')\s*(;\s*(.*?)\s*)?-->/si';
		}
	}
	// search TEXT fields
	if ($request_text_string) {
		$query = 'SELECT fieldname, artikel_archiv, freigabe, nr, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, text, verfallsdatum, seclevel, changer, last_modify'.$perm_stufe4.' FROM '.CPO_CONTENT_TEXT.', '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
			.'WHERE '.CPO_CONTENT_TEXT.'.article_id = '.CPO_NEWS.'.nr '
			.'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
			.$permission
			.$request_text_string
			.$freigabe
			.$pubdatum
//			.$sec_rubrics
			.$qrubrics;
//		echo $query;
//		echo "<br /> ";
		$db->query($query);
		while ($db->next_record_assoc()) {
			$recNr = $db->v('nr');
			$results[$recNr] = $db->record();
			$fmatches[$recNr]=$results[$recNr]['fieldname'];
			$searchFields[$results[$recNr]['fieldname']][] = $recNr; 
			$results[$recNr]['result'] = $results[$recNr]['text'];
			$results[$recNr]['sort_date'] = $results[$recNr]['pub_datum'];
//			$results[$recNr]['fieldnamePreg'] = '/<!--\s*(file|html|image|text|url|value)\s*:\s*('.preg_quote($results[$recNr]['fieldname']).')\s*(;\s*(.*?)\s*)?-->/si';
		}
	}
//	echo "<hr /> ";
//	print_r ($results);
//	echo "<hr /> ";
//	print_r($searchFields);
//	echo "<hr /> ";
//	print_r($fmatches);
//	echo "<hr /> ";

	// Jetzt prfen wir, ob AND oder OR gilt...
	// ******************************************************************************************************
	// OR = alle Treffer gelten
/*	foreach($searchFields AS $fName) {
		foreach($fName AS $fmatch)  {
			$fmatches[$fmatch]=$fmatch;
		}
	}*/
	$aMatches = array_keys($fmatches);
//	$aMatches['value'] = 0;
//	print_r($aMatches);
//	echo "<hr /> ";
//	echo "<hr /> ";
	$inString = "(".implode(",",$aMatches).")"; // die Treffer als Werteliste
//	echo $inString; // die Treffer als Werteliste

	// AND = es mssen alle Kriterien stimmen
	if ($_REQUEST['results'] == 'AND')
	{
		foreach($aMatches AS $key=>$aMatch) {
			foreach($searchFields AS $fName=>$val) {
				if (!in_array($aMatch,$searchFields[$fName])) unset ($aMatches[$key]);
			}
		}
	}
//	echo "<hr /> ";
	$inString = "(".implode(",",$aMatches).")"; // die Treffer als Werteliste
//	echo $inString; // die Treffer als Werteliste
	// ******************************************************************************************************

	// alle Resultate lschen die nach der UND-Prfung ungltig sind
	foreach ($results as $k=>$v) 
	{
		if (!in_array($k,$aMatches)) unset ($results[$k]);
	}
	
//	echo "<hr /> ";
	// mit den gesammelten Nummern holen wir uns jetzt die Inhalte
	if (count($results) > 0)
	{
		$query = 'SELECT * FROM '.CPO_CONTENT_TEXT.' WHERE article_id IN '.$inString;
		$db->query($query);
		while ($db->next_record_assoc()) 
		{
			$results_output[$db->v('nr')] = $db->record();
			$feldname = $results_output[$db->v('nr')]['fieldname'];
			$possible_fieldnames[$feldname] = 1;
			$artikelnummer = $results_output[$db->v('nr')]['article_id'];
			$results_output_fields[$artikelnummer][$feldname] = $results_output[$db->v('nr')]['text'];
		}

		$query = 'SELECT * FROM '.CPO_CONTENT_HTML.' WHERE article_id IN '.$inString;
		$db->query($query);
		while ($db->next_record_assoc()) 
		{
			$results_output[$db->v('nr')] = $db->record();
			$feldname = $results_output[$db->v('nr')]['fieldname'];
			$possible_fieldnames[$feldname] = 1;
			$artikelnummer = $results_output[$db->v('nr')]['article_id'];
			$results_output_fields[$artikelnummer][$feldname] = $results_output[$db->v('nr')]['html'];
		}

		$query = 'SELECT * FROM '.CPO_CONTENT_URLS.' WHERE article_id IN '.$inString;
		$db->query($query);
		while ($db->next_record_assoc()) 
		{
			$results_output[$db->v('nr')] = $db->record();
			$feldname = $results_output[$db->v('nr')]['fieldname'];
			$possible_fieldnames[$feldname] = 1;
			$artikelnummer = $results_output[$db->v('nr')]['article_id'];
			$results_output_fields[$artikelnummer][$feldname] = $results_output[$db->v('nr')]['url'];
		}

		$query = 'SELECT article_id, fieldname, datei FROM '.CPO_CONTENT_FILES.', '.CPO_DATA.' WHERE  '.CPO_CONTENT_FILES.'.file_id='.CPO_DATA.'.id AND '.CPO_CONTENT_FILES.'.article_id IN '.$inString;
		$db->query($query);
		while ($db->next_record_assoc()) 
		{
			$results_output[$db->v('nr')] = $db->record();
			$feldname = $results_output[$db->v('nr')]['fieldname'];
			$possible_fieldnames[$feldname] = 1;
			$artikelnummer = $results_output[$db->v('nr')]['article_id'];
			$results_output_fields[$artikelnummer][$feldname] = $results_output[$db->v('nr')]['datei'];
		}

		$query = 'SELECT article_id, fieldname, datei FROM '.CPO_CONTENT_IMAGES.', '.CPO_DATA.' WHERE  '.CPO_CONTENT_IMAGES.'.image_id='.CPO_DATA.'.id AND '.CPO_CONTENT_IMAGES.'.article_id IN '.$inString;
		$db->query($query);
		while ($db->next_record_assoc()) 
		{
			$results_output[$db->v('nr')] = $db->record();
			$feldname = $results_output[$db->v('nr')]['fieldname'];
			$possible_fieldnames[$feldname] = 1;
			$artikelnummer = $results_output[$db->v('nr')]['article_id'];
			$results_output_fields[$artikelnummer][$feldname] = $results_output[$db->v('nr')]['datei'];
		}

	}
//	print_r ($results);
//	echo "<hr /> ";

	foreach ($results as $k=>$v) 
	{
		if (is_array($results_output_fields[$k])) $results[$k] = array_merge($results[$k],$results_output_fields[$k]);
	}
//	print_r ($results);

	// Sortierung
	$results = SortArray($results,$activeModules[$directory]['sortingField'],$activeModules[$directory]['sortingOrder']);
	// Die Treffer befinden sich jetzt in $results
	
} // End $_REQUEST['action'] == 'feature_search'

?>