<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Feature-Search"			                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.1 / Mrz 2013

*/
	
if (!defined('CPO')) exit;


if (!function_exists('search_multitemplate_parser')) {
	function search_multitemplate_parser ($template, $ersetzungs_array, $sql_res_array)
	{

	   GLOBAL $bereich_ende;
	   $inhalt_neu = array();
	   $start_flag  = 0;
	   $marke_start = 0; 
	   $marke_ende  = 0;
	   $bereich_start = 0;
	   $plh_zeilen  = "";
	   $inhalt_tpl  = explode("\n",$template);
	   while (list ($zeilennummer, $zeile) = each ($inhalt_tpl)) {
		 if ($zeilennummer > $bereich_ende) {
		   if (ereg ('<!-- START_MOD_SEARCH -->', $zeile))
			 $bereich_start = $zeilennummer;
		   elseif (ereg ('<!-- ENDE_MOD_SEARCH -->', $zeile)) {
			 $bereich_ende = $zeilennummer+1;
			 break;
		   }
		 }
	   }

	   $inhalt_tpl  = explode("\n",$template);
	   while (list ($zeilennummer, $zeile) = each ($inhalt_tpl)) {
		 if (($zeilennummer > $bereich_start) and ($zeilennummer <= $bereich_ende)) {

		   if ($start_flag == 0) {
			 if (ereg ('<!-- START_SEARCH_MATCH -->', $zeile)) {
				$start_flag = 1;
				$marke_start = $zeilennummer;
			 }
		   } elseif (ereg ('<!-- ENDE_SEARCH_MATCH -->', $zeile)) {
				$start_flag = 0;
				$marke_ende = $zeilennummer;
		   } else
				$plh_zeilen .= $zeile;
		 }
	   }
	  
	  $tmp_plh_zeilen = "";

	   //$anzahl_sql_ergebnis = count($sql_res_array);
	  for ($i = 0; $i < count($sql_res_array); $i++) {
		$tmp = $plh_zeilen;

		for ($j = 0; $j < count($ersetzungs_array); $j++) {
		  $ers_tag = $ersetzungs_array[$j][0];
		  $index   = $ersetzungs_array[$j][1];

		  $sql_res_array[$i][$index] = stripslashes ($sql_res_array[$i][$index]);
		  $tmp = str_replace($ers_tag, $sql_res_array[$i][$index], $tmp);
		  $tmp = stripslashes($tmp);
		}
		$tmp_plh_zeilen .= $tmp;
	  }
	   $plh_zeilen = $tmp_plh_zeilen;
	   
	  // Wiederherstellen des Datei-Inhalts
	  for ($i = $bereich_start; $i < $bereich_ende; $i++) {

		// vor der Start-Markierung
		if ($i < $marke_start) {
		   $inhalt_neu[$i] = $inhalt_tpl[$i];
		} elseif (($i >= $marke_start) and ($i < $marke_ende)) {
		// zwischen den Markierungen
		   $inhalt_neu[$i] =  $plh_zeilen;
		   $i = $marke_ende;  // Variable auf Zeile von marke_ende
		} else {
		// nach dem Markierungsende
		   $j = $marke_start + ($i - $marke_ende);
		   $inhalt_neu[$j] = $inhalt_tpl[$i];
		}
	  }
	  return ($inhalt_neu);
	}
}


if (!function_exists('messageBox')) {
	function messageBox($message)  {
		if (!isset($message)) return;

		if ((!is_array($message) && strlen($message)<=0) || 
			( is_array($message) && count($message)<=0)) {
			return;
		}

		if (!is_array($message)) $message = array($message);
		$message_box_string = '<fieldset class="message">';
			if (count($message)==1) {
				$message_box_string .= '<legend>'.htmlspecialchars(__('Message'), ENT_COMPAT, 'ISO-8859-15').'</legend>';
				foreach ($message as $v) $message_box_string .= sprintf('<p>%s</p>', $v);
			} else {
				$message_box_string .= '<legend>'.htmlspecialchars(__('Messages'), ENT_COMPAT, 'ISO-8859-15').'</legend>';
				$message_box_string .= '<ul>';
				foreach ($message as $v) $message_box_string .= sprintf('<li>%s</li>', $v);
				$message_box_string .= '</ul>';
			}
			$message = '';
		$message_box_string .=	'</fieldset> <br /> <br />';
		return $message_box_string;
	}
}

if (!function_exists('SortArray')) {
   function SortArray() {				// http://www.php.net/manual/de/function.usort.php#42535
       $arguments = func_get_args();
       $array = $arguments[0];
	   if (is_array($arguments[1]))  {	// mehrere Sortierkriterien in einem Array
		   $multi_arg = $arguments[1];
		   for ($a=0;$a<count($multi_arg);$a++)  {
			   $arguments[$a+1] = $multi_arg[$a];
		   }
	   }
       $code = '';
       for ($c = 1; $c < count($arguments); $c += 2) {
           if (in_array($arguments[$c + 1], array("ASC", "DESC"))) {
               $code .= 'if ($a["'.$arguments[$c].'"] != $b["'.$arguments[$c].'"]) {';
               if ($arguments[$c + 1] == "ASC") {
                   $code .= 'return ($a["'.$arguments[$c].'"] < $b["'.$arguments[$c].'"] ? -1 : 1); }';
               }
               else {
                   $code .= 'return ($a["'.$arguments[$c].'"] < $b["'.$arguments[$c].'"] ? 1 : -1); }';
               }
           }
       }
       $code .= 'return 0;';
       $compare = create_function('$a,$b', $code);
       usort($array, $compare);
       return $array;
   }
}

if (!function_exists('array_search_recursive')) {
	function array_search_recursive( $needle, $haystack )
	{
	   $path = NULL;
	   $keys = array_keys($haystack);
	   while (!$path && (list($toss,$k)=each($keys))) {
		 $v = $haystack[$k];
		 if (is_scalar($v)) {
			 if ($v===$needle) {
			   $path = array($k);
			 }
		 } elseif (is_array($v)) {
			 if ($path=array_search_recursive( $needle, $v )) {
			   array_unshift($path,$k);
			 }
		 }
	   }
	   return $path;
	}
}

if (!function_exists('array_search_bit')) {
	function array_search_bit($search, $array_in)  {
	   foreach ($array_in as $key => $value)  {
		   if (strpos($value, $search) !== FALSE)
		   return $key;
	   }
	   return FALSE;
	}
}

?>
