<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Feature-Search"			                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.1 / Mrz 2013

*/

if (!defined('CPO')) exit;

	if (!isset($_REQUEST['pos'])) $_REQUEST['pos'] = 0;

	if ($_REQUEST['pos']>count($results)) $_REQUEST['pos'] = count($results)-$noOfResults;
    $i = -1;

// Meldungen:
	// Keine Eingabe

	if ($num_phrases == 0 && $_REQUEST['action'] == 'feature_search') {
		$message_string = messageBox($activeModules[$directory]['noSearchstringText']);
		unset ($_REQUEST['form']);
	}
	// Keine Ergebnisse
	if ($num_phrases != 0 && count($results)<=0) {
		$message_string = messageBox($activeModules[$directory]['noMatchesText']);
		unset ($_REQUEST['form']);
	}
	// Anzahl der Suchergebnisse	
	$num_of_matches = (count($results)>0) ? sprintf($activeModules[$directory]['matchesText'], count($results)) : '' ;

	$sql_res_array = array();

	$arr_nr = 0;

    foreach ($results as $k=>$v) {
		// fetch the rubric settings into an array to avoid multiple queries...
		if (!array_key_exists($v['rubric_id'], $rubrics)) {
			$db = new DB;
			$db->query('SELECT directory, name, seclevel, settings '
				.'FROM '.CPO_RUBRIC.' '
				.'WHERE id='.(int)$v['rubric_id']);
			while ($db->next_record_assoc()) {
				$rubrics[$v['rubric_id']] = $db->record();
				$rubric_settings = unserialize($rubrics[$v['rubric_id']]['settings']);
				$num_of_articles = ($rubric_settings['noOfArticles']) ? $rubric_settings['noOfArticles'] : $cpoRubricSettingsDefaults['noOfArticles'];
			}
		}
		// Nur die Ausgabe fr die zu zeigende Seite
		$i++;
		if ($i<$_REQUEST['pos']) continue;
		if ($i>=$_REQUEST['pos']+$noOfResults) break;

		$sql_res_array[] = array(
			/* 0 */ $v['titel'],
			/* 1 */ $v['autor'],
			/* 2 */ date($activeModules[$directory]['dateFormat'], strtotime($v['pub_datum'])),
			/* 3 */ $v['result'],
			/* 4 */ $i+1,
			/* 5 */ $v['nr'],
			/* 6 */ $rubrics[$v['rubric_id']]['name'],
			/* 7 */ $v['rubric_id'],
			/* 8 */ $rubrics[$v['rubric_id']]['directory']
			);
		foreach ($possible_fieldnames as $key=>$value)
		{
			$sql_res_array[$arr_nr][] = $results_output_fields[$v['nr']][$key];
		}
		$arr_nr++;
	}

	$replace_array[] = array ("### SEARCH_TITLE ###",		"0");
	$replace_array[] = array ("### SEARCH_AUTHOR ###",		"1");
	$replace_array[] = array ("### SEARCH_PUB_DATE ###",	"2");
	$replace_array[] = array ("### SEARCH_CONTENT ###",		"3"); // ???
	$replace_array[] = array ("### SEARCH_NUM ###",			"4");
	$replace_array[] = array ("### SEARCH_ARTICLE_ID ###",	"5");
	$replace_array[] = array ("### SEARCH_RUBRIC ###",		"6");
	$replace_array[] = array ("### SEARCH_RUBRIC_ID ###",	"7");
	$replace_array[] = array ("### SEARCH_RUBRIC_DIR ###",	"8");

	if (is_array($possible_fieldnames))
	{
		$z=1;
		foreach ($possible_fieldnames as $key=>$value)
		{
			$replace_array[] = array ("### SEARCH_".$key." ###",	(8+$z) );
			$z++;
		}
	}
//	print_r ($replace_array);
	$parsed = search_multitemplate_parser ($activeModules[$directory]['template'], $replace_array, $sql_res_array);
	while (list($zeile, $page_row) = each ($parsed))  $page_string .= $page_row;
	for ($n=1;$n<=100;$n++)  {
		$page_string = str_replace("### SEARCH_PHRASE_".$n." ###",	$_REQUEST['p'.$n],		$page_string);
	}
	$page_string = str_replace("### SEARCH_PAGES ###",		$pagination,			$page_string);
	$page_string = str_replace("### SEARCH_NAV ###",		$_REQUEST['rubric'],	$page_string);
	$page_string = str_replace("### SEARCH_MESSAGE ###",	$message_string,		$page_string);
	$page_string = str_replace("### SEARCH_MATCHES ###",	$num_of_matches,		$page_string);
	$page_string = str_replace("### SEARCH_FORM ###",	(isset($_REQUEST['form']) ? $_REQUEST['form'] : 'inline') ,		$page_string); // das noch als Einstellung
	if (is_array($selects)) 
	{
		foreach($selects as $k=>$s) $page_string = str_replace("### S".$k."_".htmlspecialchars($s, ENT_COMPAT, 'ISO-8859-15')." ###",	'selected="selected"',			$page_string);
	}

	// finale Suberung
	$suchmuster = "/### SEARCH_([^#]*) ###/";
	if (preg_match_all($suchmuster, $activeModules[$directory]['template'], $treffer))
	$page_string = preg_replace($suchmuster, "", $page_string);	

	if (!isset($mute)) echo $page_string;


?>