<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Feature-Search"			                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.1 / Mrz 2013

*/

define('CPO', true);
require_once('../_include/common.inc.php');
$directory = basename(dirname($_SERVER['PHP_SELF']));

require(CPO_BASEDIR.'_include/var_category.php');
require(CPO_BASEDIR.'_include/secure.php');

// the includes ***********************************************************************************
require_once(CPO_BASEDIR.$directory.'/includes/inc_search_function.inc.php');
include_once(CPO_BASEDIR.$directory.'/includes/actions.inc.php');

ob_start();
if (
	(!array_key_exists($directory, $activeModules)) || 
	(license($activeModules[$directory]['lkey'],$activeModules[$directory]['mod_id'])!=1 && license($activeModules[$directory]['lkey'],$activeModules[$directory]['mod_id'])!=3)
	) {
    $message[] = ___('The form is currently disabled.');
	include(CPO_BASEDIR.'_include/message.php');
} else {
	if (
			( $activeModules[$directory]['hideArticles'] == "no" && $activeModules[$directory]['showArticles'] == "before" ) ||
			( $_REQUEST['action'] != 'feature_search' && $cpoRubric['id'] && $activeModules[$directory]['showArticles'] == "before" )
		) require(CPO_BASEDIR.'_includesite/i_index.php');

	$zusatzurl = '';
	foreach ($_REQUEST as $key=>$value)
	{
		if ($key == session_name()) continue;
		if ($key == 'pos') continue;
		$zusatzurl .= $key.'='.urlencode($value).'&amp;';
	}

	$pagination = string_next_page($_REQUEST['pos'], count($results), $noOfResults, true, $zusatzurl, '', $tl);

	include(CPO_BASEDIR.$directory.'/includes/parser.inc.php');

	if (
			( $activeModules[$directory]['hideArticles'] == "no" && $activeModules[$directory]['showArticles'] == "after" ) ||
			( $_REQUEST['action'] != 'feature_search' && $cpoRubric['id'] && $activeModules[$directory]['showArticles'] == "after" )
		) require(CPO_BASEDIR.'_includesite/i_index.php');
}
$showForm = ob_get_clean();


// header and footer mechanism
if (($cpoRubricSettings['pagetemplate_'.$pagetype]==0 && $activeModules[$directory]['pagetemplate_index'] == -2) || $activeModules[$directory]['pagetemplate_index']==0) {
    include(CPO_BASEDIR.$directory.'/loadheaders.php');
    echo $showForm;
	include(CPO_BASEDIR.$directory.'/loadfooters.php');
    exit;
}

// fetch pagetemplate from database and build page
$pagetemplate = ($activeModules[$directory]['pagetemplate_index']==-2) ? $cpoRubricSettings['pagetemplate_'.$pagetype] : $activeModules[$directory]['pagetemplate_index'];

$db = new DB;
$db->query('SELECT pagetemplate FROM '.CPO_PAGETEMPLATES.' '
    .'WHERE id='.(int)$pagetemplate.' '
);
$db->next_record();
$pageTemplate = $db->v('pagetemplate');
$pageTagsPreg = '/<!--\s*page\s*:\s*articles\s*(?!id=)[^>]\s*-->/isU'; // nur der Artikelplatzhalter der aktuellen Rubrik, also OHNE id
$pageTemplate = preg_replace ($pageTagsPreg, $showForm, $pageTemplate);
require CPO_BASEDIR.'_include/buildpage.inc.php';

?>
